//+------------------------------------------------------------------+
//|                                            RSI AREA adviser.mq4  |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//| Make by Slawa Starikoff  aka Stringo
//| Modified by Victor Lukashuk aka lukas1          ver.005
//+------------------------------------------------------------------+
//   ,  ,  
//  : RSI & 50    
//      . 
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"
 
extern int RSIPeriod=4;
extern int AreaCondition=30; //-   
extern int bar_of_life=20; //      
extern int TP=180;
extern int SL=60;
extern double lot=0.1;
static double RSIArea,RSIOpen;
static int RSIAreaShift=0;
//----
int init() {return(0);}
int deinit() {return(0);}
//---- 
//  :1.;2.;3..
int start()
 {
  int cnt, shift,ord_b=0,ord_s=0;
  double RSICurrent, RSILocalMin, RSILocalMax, value;
//----
  //:      
  RSICurrent = iRSI(NULL, 0, RSIPeriod, PRICE_OPEN, 0);
  if(RSIOpen>50 && RSICurrent>50) return(0);
  if(RSIOpen<50 && RSICurrent<50) return(0);      
  RSILocalMin = RSICurrent;
  RSILocalMax = RSICurrent;

  for(shift=1; shift<RSIAreaShift; shift++)
   {
    value = iRSI(NULL, 0, RSIPeriod, PRICE_OPEN, shift);
    if(value<RSILocalMin && RSIArea>0) RSILocalMin=value;
    if(value>RSILocalMax && RSIArea<0) RSILocalMax=value;
   }   
//----
  //    
  for(cnt=OrdersTotal()-1; cnt>=0; cnt--)
     {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderMagicNumber()==111222 && OrderSymbol()==Symbol())
       {
        if(OrderType()==OP_BUY)
         {ord_b++;
          if((OrderOpenTime()<(TimeCurrent()-bar_of_life*60*Period())) ||
             (RSILocalMax>=RSICurrent+4 && RSILocalMax>50)  
            )
             OrderClose(OrderTicket(),OrderLots(),Bid,3);
         }
        if(OrderType()==OP_SELL)
         {ord_s++;
          if((OrderOpenTime()<(TimeCurrent()-bar_of_life*60*Period())) ||
             (RSILocalMin<=RSICurrent-4 && RSILocalMin<50 )
            )
             OrderClose(OrderTicket(),OrderLots(),Ask,3);
         }
       }
     }
        
//----
  //  
  if(ord_b+ord_s<1)
   {
    RSIArea = RSIAreaFunc(RSIAreaShift, RSIPeriod, 0);
    if(RSIArea<-AreaCondition)
     {
      OrderSend(Symbol(),OP_BUY,lot,Ask,3,Ask-SL*Point,Ask+TP*Point,"",111222);
      RSIOpen = iRSI(NULL, 0, RSIPeriod, PRICE_OPEN, 0);
      return(0);
     }
    if(RSIArea>AreaCondition)
     {
      OrderSend(Symbol(),OP_SELL,lot,Bid,3,Bid+SL*Point,Bid-TP*Point,"",111222);
      RSIOpen = iRSI(NULL, 0, RSIPeriod, PRICE_OPEN, 0);
      return(0);
     }    
   }



  return(0);
 }
//----
double RSIAreaFunc(int& RSIAreaShift, double RSIPeriod, int BeginShift)
 {
  int shift;
  double rsivalue, result; 
  //:      
  result = iRSI(NULL, 0, RSIPeriod, PRICE_OPEN, BeginShift) - 50.0;
  //:   "BeginShift+1"  "BeginShift+RSIAreaShift+1"
  for(shift=BeginShift+1; shift<BeginShift+RSIAreaShift+1; shift++)
   {
    rsivalue = iRSI(NULL, 0, RSIPeriod, PRICE_OPEN, shift) - 50.0;
    if((result>0 && rsivalue<-3) || (result<0 && rsivalue>3))
     {
      RSIAreaShift=shift;
      break;
     }
    result += rsivalue;
   }
  return(result);
 }

